<script setup lang="ts">
import { onMounted, ref, watch } from 'vue'
import { useRoute, useRouter } from 'vue-router'
import type { Project } from '@/api/gitlabHelperApi/projectsApi'
import ProjectsApi from '@/api/gitlabHelperApi/projectsApi'
import PipelineListComponent from '@/components/gitlab/PipelineListComponent.vue'
import PipelineSetupComponent from '@/components/gitlab/PipelineSetupComponent.vue'
import ScheduleListComponent from '@/components/gitlab/ScheduleListComponent.vue'

const project = ref<Project | null>(null)

const route = useRoute()
const router = useRouter()

const selectTab = ref(route.query.tab ? Number.parseInt(route.query.tab, 10) : 0)

watch(selectTab, newTab => {
  console.debug('DEBUG: selectTab', newTab)
  router.replace({ query: { ...route.query, tab: newTab } })
})

const getProject = async () => {
  console.info('INFO: getProject')

  const projectsApi = new ProjectsApi()
  try {
    const response = await projectsApi.getProject(route.params.projectId as string)

    project.value = response.data.data
    console.debug('DEBUG: project.value: ', project.value)
  }
  catch (error) {
    console.debug('ERROR: error: ', error)
  }
}

onMounted(() => {
  getProject()
})
</script>

<template>
  <VCard>
    <VTabs v-model="selectTab">
      <VTab>
        Setup
      </VTab>
      <VTab>
        Executions
      </VTab>
      <VTab>
        Schedules
      </VTab>
    </VTabs>
    <VCardText>
      <VWindow v-model="selectTab">
        <VWindowItem value="0">
          <PipelineSetupComponent v-if="selectTab === 0" />
        </VWindowItem>
        <VWindowItem value="1">
          <PipelineListComponent
            v-if="selectTab === 1 && project !== null"
            :project="project"
          />
        </VWindowItem>
        <VWindowItem value="2">
          <ScheduleListComponent v-if="selectTab === 2" />
        </VWindowItem>
      </VWindow>
    </VCardText>
  </VCard>
</template>
